/*
 * File         : testWriteHalo.java
 * Author       : Guansong Zhang
 * Created      : Fri Jan 23 11:23:30 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1998/04/21 21:41:45 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class testWriteHalo {

  static final int n=8;
  static SpmdEnv spmd;
  static Procs2  p;
  static BlockRange x,y;
  static Array2ddF u,uold;
  static Index i,j,ic,jc;

  public static void main(String argv[]) {
    spmd = new SpmdEnv(argv);

    p=new Procs2(2,2);

    if (p.on()) {

      int [] w = {1,1};
      
      // enum Layout {LAY_STANDARD, LAY_PACKED, LAY_ADAPT, LAY_EXTENDED}

      x = new BlockRange (n, p.dim(0), 3, 1, 1);
      y = new BlockRange (n, p.dim(1), 3, 1, 1);

      u = new Array2ddF(spmd.apg,x,y);

      i = new Index (x);
      j = new Index (y);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  if (x.idx(i)==0 || x.idx(i)==n-1 || y.idx(j)==0 || y.idx(j)==n-1)
	    u.dat()[u.pos(i, j)]=1;
	  else
	    u.dat()[u.pos(i, j)]=0;
	} j.dim().revo();
      } i.dim().revo();

      uold = new Array2ddF(spmd.apg, x, y);

      Index ic = new Index (x.subrng(n-2, 1));
      Index jc = new Index (y.subrng(n-2, 1));

      for (int iter=1; iter<=5; iter++) {

	Adlib.copy(uold, u);
	Adlib.writeHalo(uold,w,w);

	ic.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  jc.dim().over();
	  for (jc.begin(); jc.test(); jc.next()) {
	    u.dat()[u.pos(ic,jc)]
	      =(float)0.25*(uold.dat()[uold.pos(ic.shift(-1),jc)]+
			    uold.dat()[uold.pos(ic.shift(1),jc)]+
			    uold.dat()[uold.pos(ic,jc.shift(-1))]+
			    uold.dat()[uold.pos(ic,jc.shift(1))]);
	  } jc.dim().revo();
	} ic.dim().revo();

	Adlib.rprintln("iteration = "+iter);

	Adlib.aprintf("%7.3f%"+n+"N", u);
      }

    } p.no();

    spmd.finalize();
  }
}
